EBooking/Areas/Admin/Controllers/CategoryController.cs
using Microsoft.AspNetCore.Mvc;
using EBooking.DataAccess;
using EBooking.Models;

namespace EBooking.Controllers
{
    [Area("Admin")]
    public class CategoryController : Controller
    {
        private readonly IEBookingDbRepositories _dbRep;
        private readonly ICategoryRepository _categoryRep;
        public CategoryController(IEBookingDbRepositories dbRep)
        {
            _dbRep = dbRep;
            _categoryRep = _dbRep.CategoryRep;
        }
     
        public IActionResult Index()
        {
            var categories = _categoryRep.GetAll();
            return View(categories);
        }
        //Get
        public ActionResult Create()
        {
            return View();
        }
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(Category obj )
        {
            if(obj.Name == obj.DisplayOrder.ToString())
            {
                ModelState.AddModelError("CustomError", "Name and display order should not be same");
            }
            if(ModelState.IsValid)
            {
                _categoryRep.Add(obj);
                _dbRep.Save();
                TempData["success"] = "Category created successfully";
                return RedirectToAction("Index");
            }

            return View(obj);
        }
        //Get
        public ActionResult Edit(int? id)
        {
            var category = _categoryRep.GetFirstOrDefault(c => c.Id == id);  
            if(category == null)
            {
                return NotFound();
            }
            return View(category);
        }
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(Category obj)
        {
            if (obj.Name == obj.DisplayOrder.ToString())
            {
                ModelState.AddModelError("CustomError", "Name and display order should not be same");
            }
            if (ModelState.IsValid)
            {
                _categoryRep.Update(obj);
                _dbRep.Save();
                TempData["success"] = "Category updated successfully";
                return RedirectToAction("Index");
            }

            return View(obj);
        }
        //Get
        public ActionResult Delete(int? id)
        {
            var category = _categoryRep.GetFirstOrDefault(c => c.Id == id);
            if (category == null)
            {
                return NotFound();
            }
            return View(category);
        }
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeletePost(int? id)
        {
            var category = _categoryRep.GetFirstOrDefault(c => c.Id == id);
            if(category != null)
            {
                _categoryRep.Remove(category);
                _dbRep.Save();
                TempData["success"] = "Category deleted successfully";
                return RedirectToAction(nameof(Index));
            }
            else
            {
                return NotFound();
            }
            return View(category);
        }

    }
}

EBooking/Areas/Admin/Controllers/CompanyController.cs
using Microsoft.AspNetCore.Mvc;
using EBooking.DataAccess;
using EBooking.Models;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace EBooking.Controllers
{
    [Area("Admin")]
    public class CompanyController : Controller
    {
        private readonly IEBookingDbRepositories _db;
        public CompanyController(IEBookingDbRepositories db)
        {
            _db = db;
        }
        public IActionResult Index()
        {
            return View();
        }
        //Get
        public ActionResult Upsert(int? id)
        {
            Company company = new();
            if(id ==0 || id== null)
            {
                return View(company);
            }
            else
            {
                company = _db.CompanyRep.GetFirstOrDefault(u => u.Id == id);
                return View(company);
            }
        }
        [HttpPost]
        public IActionResult Upsert(Company obj)
        {
            if (ModelState.IsValid)
            {
                if (obj.Id == 0)
                {
                    _db.CompanyRep.Add(obj);
                }
                else
                {
                    _db.CompanyRep.Update(obj);
                }
                _db.Save();
                TempData["success"] = "Company created successfully";
                return RedirectToAction("Index");
            }
            return View(obj);
        }

        #region "API Calls"
        [HttpGet]
        public ActionResult GetAll()
        {
            var allCompanies = _db.CompanyRep.GetAll();
            return Json(new {data=allCompanies});    
        }

        [HttpDelete]
        public IActionResult Delete(int? id)
        {
            var company = _db.CompanyRep.GetFirstOrDefault(u=> u.Id== id);
            if(company == null)
            {
                return Json(new { success = false, message = "Error while deleting" });
            }            _db.CompanyRep.Remove(company);
            _db.Save();
            return Json(new { success = true, message = "Company deleted successfully" });
            
        }
        #endregion  
    }
}

EBooking/Areas/Admin/Controllers/OrderController.cs
using Microsoft.AspNetCore.Mvc;
using EBooking.Models;
using EBooking.DataAccess;
using EBooking.Utilities;

namespace EBooking.Areas.Admin.Controllers
{
    [Area("Admin")]
    public class OrderController : Controller
    {
        private readonly IEBookingDbRepositories _db;
        public OrderController(IEBookingDbRepositories db)
        {
            _db = db;
        }
        public IActionResult Index()
        {
            return View();  
        }

        #region APICalls
        [HttpGet]
        public IActionResult GetAll(string status)
        {
            var orderHeaders = _db.OrderHeaderRep.GetAll(includeProperties: "ApplicationUser");
            switch (status)
            {
                case "pending":
                    orderHeaders = orderHeaders.Where(u=> u.PaymentStatus == SD.PaymentStatusForDelayedPayment);
                    break;
                case "inprocess":
                    orderHeaders = orderHeaders.Where(u => u.OrderStatus == SD.StatusInprocess);
                    break;
                case "completed":
                    orderHeaders = orderHeaders.Where(u => u.OrderStatus == SD.StatusApproved);
                    break;
                case "approved":
                    orderHeaders = orderHeaders.Where(u => u.OrderStatus == SD.StatusApproved);
                    break;
                default:
                    break;

            }
            return Json(new { data = orderHeaders });
        }
        #endregion

    }



}

EBooking/Areas/Admin/Controllers/ProductController.cs
using Microsoft.AspNetCore.Mvc;
using EBooking.DataAccess;
using EBooking.Models;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace EBooking.Controllers
{
    [Area("Admin")]
    public class ProductController : Controller
    {
        private readonly IEBookingDbRepositories _db;
        private readonly IWebHostEnvironment _hostEnvironment;
     
        public ProductController(IEBookingDbRepositories db, IWebHostEnvironment webHostEnvironment)
        {
            _db = db;
            _hostEnvironment = webHostEnvironment;
        }

        public IActionResult Index()
        {
            return View();
        }
        //Get
        public ActionResult Upsert(int? id)
        {
            ProductVM productVM = new()
            {
                Product = new(),
                CategoryList = _db.CategoryRep.GetAll().Select(
                                                               c => new SelectListItem
                                                               {
                                                                   Text = c.Name,
                                                                   Value = c.Id.ToString()
                                                               }),
                CoverTypeList = _db.CoverTypeRep.GetAll().Select(
                                                           c => new SelectListItem
                                                           {
                                                               Text = c.Name,
                                                               Value = c.Id.ToString()
                                                           })
            };
            if(id ==0 || id== null)
            {
                return View(productVM);
            }
            else
            {
                productVM.Product = _db.ProductRep.GetFirstOrDefault(u => u.Id == id);
                return View(productVM);
            }
           
        }
        [HttpPost]
        public IActionResult Upsert(ProductVM obj, IFormFile? file)
        {
            if (ModelState.IsValid)
            {
                string wwwRootPath = _hostEnvironment.WebRootPath;
                if (file != null)
                {
                    string fileName = Guid.NewGuid().ToString();
                    var uploads = Path.Combine(wwwRootPath, @"product-images");
                    var extension = Path.GetExtension(file.FileName);

                    if (obj.Product.ImageUrl != null)
                    {
                        var oldImagePath = Path.Combine(wwwRootPath, obj.Product.ImageUrl.TrimStart('\\'));
                        if (System.IO.File.Exists(oldImagePath))
                        {
                            System.IO.File.Delete(oldImagePath);
                        }
                    }

                    using (var fileStreams = new FileStream(Path.Combine(uploads, fileName + extension), FileMode.Create))
                    {
                        file.CopyTo(fileStreams);
                    }
                    obj.Product.ImageUrl = @"\product-images\" + fileName + extension;

                }
                if (obj.Product.Id == 0)
                {
                    _db.ProductRep.Add(obj.Product);
                }
                else
                {
                    _db.ProductRep.Update(obj.Product);
                }
                _db.Save();
                TempData["success"] = "Product created successfully";
                return RedirectToAction("Index");
            }
            return View(obj);
        }

        #region "API Calls"
        [HttpGet]
        public ActionResult GetAll()
        {
            var allProducts = _db.ProductRep.GetAll(includeProperties:"Category,CoverType");
            return Json(new {data=allProducts});    
        }

        [HttpDelete]
        public IActionResult Delete(int? id)
        {
            var product = _db.ProductRep.GetFirstOrDefault(u=> u.Id== id);
            if(product == null)
            {
                return Json(new { success = false, message = "Error while deleting" });
            }

            var oldImagePath = Path.Combine(_hostEnvironment.WebRootPath, product.ImageUrl.TrimStart('\\'));
            if (System.IO.File.Exists(oldImagePath))
            {
                System.IO.File.Delete(oldImagePath);
            }

            _db.ProductRep.Remove(product);
            _db.Save();
            return Json(new { success = true, message = "Product deleted successfully" });
            
        }
        #endregion  
    }
}

EBooking/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - EBooking</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
     <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap-lux.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/EBooking.styles.css" asp-append-version="true" />
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.8.3/font/bootstrap-icons.css">
    <link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.css" />
    <link rel="stylesheet" href="//cdn.datatables.net/1.12.1/css/jquery.dataTables.min.css" />
 
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-light border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="Customer" asp-controller="Home" asp-action="Index">EBooking</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-white" asp-area="Customer" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle " data-bs-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Content Management</a>
                            <div class="dropdown-menu">
                                <a class="nav-link text-dark" asp-area="Admin" asp-controller="Category" asp-action="Index">Categories</a>
                                <a class="nav-link text-dark" asp-area="Admin" asp-controller="CoverType" asp-action="Index">CoverTypes</a>
                                <a class="nav-link text-dark" asp-area="Admin" asp-controller="Product" asp-action="Index">Products</a>
                                <div class="dropdown-divider"></div>
                                <a class="nav-link text-dark" asp-area="Admin" asp-controller="Company" asp-action="Index">Companies</a>
                            </div>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" asp-area="Customer" asp-controller="Cart" asp-action="Index"><i class="bi bi-cart" style="font-size:20px"></i></a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" asp-area="Admin" asp-controller="Order" asp-action="Index"><i class="bi bi-cart" ></i>Manage Orders</a>
                        </li>
                    </ul>
                    <partial name="_LoginPartial" />
                </div>
            </div>
        </nav>
    </header>
    <div class="container-fluid">
        <main role="main" class="pb-3">
            <partial name="_Notification" />
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2022 - EBooking - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    <script src="~/lib/jquery-validation/dist/jquery.validate.min.js"></script>
    <script src="~/lib/jquery-validation-unobtrusive/jquery.validate.unobtrusive.min.js"></script>
    <script src="//cdn.datatables.net/1.12.1/js/jquery.dataTables.min.js"></script>
    <script src="//cdn.jsdelivr.net/npm/sweetalert2@11"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js"></script>

    @await RenderSectionAsync("Scripts", required: false)

</body>
</html>

EBooking/Views/Shared/_Notification.cshtml
@if(TempData["success"] != null)
{
    @*<h2><b>@TempData["success"]</b></h2> *@

    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js"></script>
    <script type="text/javascript">
        toastr.success('@TempData["success"]');
    </script>
}
else if(TempData["error"] != null)
{
      @* <h2><b>@TempData["error"]</b></h2> *@
       <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js"></script>
    <script type="text/javascript">
        toastr.error('@TempData["error"]');
    </script>

}